module Gremlin
  class MetricsController < ::ActionController::Base
    def index
      render plain: marshal.join("\n")
    end

    def marshal
      registry = Gremlin.registry

      metrics = registry.metrics.map do |metric|
        metric.repr_and_delete
      end

      plaintext(metrics)
    end

    def plaintext(metric_representations)
      lines = []
      metric_representations.each do |repr|
        lines << repr[:type]
        lines << repr[:help]

        # Prometheus expects metric labels to be of the format <label>="<label_value>"
        repr[:values].each do |labels, value|
          l = []
          labels.each do |k,v|
            l << "#{k}=\"#{v}\""
          end
          lines << "#{repr[:name].to_s}{#{l.join(',')}} #{value}"
        end
      end
      lines
    end
  end
end
