module Gremlin
  module NotificationObserver
    class CounterReceiver
      def initialize(name, docstring, labels)
        @instrument = Gremlin::Instruments::Counter.new(name, docstring, labels)
        begin
          Gremlin.registry.register @instrument
        rescue Gremlin::Registry::AlreadyRegisteredError; end
      end

      def call(name, start, finish, id, payload)
        instrument.increment({})
      end

      def instrument
        Gremlin.registry.get(@instrument.name)
      end
    end

    class SummaryReceiver
      def initialize(name, docstring, labels, payload_field)
        @instrument = Gremlin::Instruments::Summary.new(name, docstring, labels)
        begin
          Gremlin.registry.register @instrument
        rescue Gremlin::Registry::AlreadyRegisteredError; end
        @field_to_observe = payload_field
      end

      def call(name, start, finish, id, payload)
        instrument.observe({}, payload[@field_to_observe.to_sym])
      end

      def instrument
        Gremlin.registry.get(@instrument.name)
      end
    end
  end
end
