module Gremlin
  module Quantile
    class Percentile
      attr_accessor :percent

      def initialize(percent)
        @percent = percent
        raise unless @percent
      end

      def to_h
        {
          percent: @percent,
        }
      end

      def calculate(sorted_values)
        sorted_values[(@percent * sorted_values.count).to_i]
      end

      def serialize
        to_h.to_json
      end
    end
  end
end
